--*****************************************************************************
--* Author: falcontx
--* Summary: Hook keybindings to set initial defaults and allow proper resets.
--*****************************************************************************

local UIUtil = import('/lua/ui/uiutil.lua')
local initDefaultKeyMap = import('/mods/AutoGive/keymapping.lua').initDefaultKeyMap
local originalCreateUI = CreateUI

function CreateUI()
  local keyLookup = import('/lua/keymap/keymapper.lua').GetKeyLookup()
  if keyLookup['autogive_ally1'] == nil then
    UIUtil.QuickDialog(GetFrame(0), "No keys assigned for AutoGive. Assign falcontx's defaults?",
        "<LOC _Yes>", function() initDefaultKeyMap() originalCreateUI() end,
        "<LOC _No>", originalCreateUI,
        nil, nil,
        true, 
        {escapeButton = 2, enterButton = 1, worldCover = true})
  else
    originalCreateUI()
  end
end
