local KeyMapper = import('/lua/keymap/keymapper.lua')
local lazyshare_active = false

autogiveDefaultKeyMap = {
  ['Ctrl-Shift-F1'] = 'give_units_ally1',
  ['Ctrl-Shift-F2'] = 'give_units_ally2',
  ['Ctrl-Shift-F3'] = 'give_units_ally3',
  ['Ctrl-Shift-F4'] = 'give_units_ally4',
  ['Ctrl-Shift-F5'] = 'give_units_ally5',
  ['Ctrl-Shift-F6'] = 'give_units_ally6',
  ['Shift-F1'] = 'give_mass_ally1',
  ['Shift-F2'] = 'give_mass_ally2',
  ['Shift-F3'] = 'give_mass_ally3',
  ['Shift-F4'] = 'give_mass_ally4',
  ['Shift-F5'] = 'give_mass_ally5',
  ['Shift-F6'] = 'give_mass_ally6',
  ['Ctrl-F1'] = 'give_energy_ally1',
  ['Ctrl-F2'] = 'give_energy_ally2',
  ['Ctrl-F3'] = 'give_energy_ally3',
  ['Ctrl-F4'] = 'give_energy_ally4',
  ['Ctrl-F5'] = 'give_energy_ally5',
  ['Ctrl-F6'] = 'give_energy_ally6',
  ['Ctrl-Alt-F1'] = 'autogive_ally1',
  ['Ctrl-Alt-F2'] = 'autogive_ally2',
  ['Ctrl-Alt-F3'] = 'autogive_ally3',
  ['Ctrl-Alt-F4'] = 'autogive_ally4',
  ['Ctrl-Alt-F5'] = 'autogive_ally5',
  ['Ctrl-Alt-F6'] = 'autogive_ally6',
}

lazyshareDefaultKeyMap = {
  ['Ctrl-Alt-Num1'] = 'autogive_ally1',
  ['Ctrl-Alt-Num2'] = 'autogive_ally2',
  ['Ctrl-Alt-Num3'] = 'autogive_ally3',
}

function initUserKeyActions()
  for i, mod in __active_mods do
    if mod["uid"] == "c31251c0-8199-11dd-ad8b-0800200c9a66" then
      lazyshare_active = true
      continue
    end
  end
  local number = 110
  if not lazyshare_active then
    KeyMapper.SetUserKeyAction('give_units_ally1', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveSelectedUnits(1, false)", category = 'diplomacy', order = number + 1})
    KeyMapper.SetUserKeyAction('give_units_ally2', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveSelectedUnits(2, false)", category = 'diplomacy', order = number + 2})
    KeyMapper.SetUserKeyAction('give_units_ally3', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveSelectedUnits(3, false)", category = 'diplomacy', order = number + 3})
    KeyMapper.SetUserKeyAction('give_units_ally4', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveSelectedUnits(4, false)", category = 'diplomacy', order = number + 4})
    KeyMapper.SetUserKeyAction('give_units_ally5', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveSelectedUnits(5, false)", category = 'diplomacy', order = number + 5})
    KeyMapper.SetUserKeyAction('give_units_ally6', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveSelectedUnits(6, false)", category = 'diplomacy', order = number + 6})
    KeyMapper.SetUserKeyAction('give_mass_ally1', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveResources(1, 'mass')", category = 'diplomacy', order = number + 7})
    KeyMapper.SetUserKeyAction('give_mass_ally2', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveResources(2, 'mass')", category = 'diplomacy', order = number + 8})
    KeyMapper.SetUserKeyAction('give_mass_ally3', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveResources(3, 'mass')", category = 'diplomacy', order = number + 9})
    KeyMapper.SetUserKeyAction('give_mass_ally4', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveResources(4, 'mass')", category = 'diplomacy', order = number + 10})
    KeyMapper.SetUserKeyAction('give_mass_ally5', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveResources(5, 'mass')", category = 'diplomacy', order = number + 11})
    KeyMapper.SetUserKeyAction('give_mass_ally6', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveResources(6, 'mass')", category = 'diplomacy', order = number + 12})
    KeyMapper.SetUserKeyAction('give_energy_ally1', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveResources(1, 'energy')", category = 'diplomacy', order = number + 13})
    KeyMapper.SetUserKeyAction('give_energy_ally2', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveResources(2, 'energy')", category = 'diplomacy', order = number + 14})
    KeyMapper.SetUserKeyAction('give_energy_ally3', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveResources(3, 'energy')", category = 'diplomacy', order = number + 15})
    KeyMapper.SetUserKeyAction('give_energy_ally4', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveResources(4, 'energy')", category = 'diplomacy', order = number + 16})
    KeyMapper.SetUserKeyAction('give_energy_ally5', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveResources(5, 'energy')", category = 'diplomacy', order = number + 17})
    KeyMapper.SetUserKeyAction('give_energy_ally6', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').giveResources(6, 'energy')", category = 'diplomacy', order = number + 18})
    KeyMapper.SetUserKeyAction('autogive_ally4', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').assassinationAutoGive(4)", category = 'diplomacy', order = number + 22})
    KeyMapper.SetUserKeyAction('autogive_ally5', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').assassinationAutoGive(5)", category = 'diplomacy', order = number + 23})
    KeyMapper.SetUserKeyAction('autogive_ally6', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').assassinationAutoGive(6)", category = 'diplomacy', order = number + 24})
  end
	KeyMapper.SetUserKeyAction('autogive_ally1', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').assassinationAutoGive(1)", category = 'diplomacy', order = number + 19})
	KeyMapper.SetUserKeyAction('autogive_ally2', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').assassinationAutoGive(2)", category = 'diplomacy', order = number + 20})
	KeyMapper.SetUserKeyAction('autogive_ally3', {action = "UI_LUA import('/mods/AutoGive/autogive.lua').assassinationAutoGive(3)", category = 'diplomacy', order = number + 21})
end

function initDefaultKeyMap()
  initUserKeyActions()
  local defaultKeyMappings = autogiveDefaultKeyMap
  if lazyshare_active then
    defaultKeyMappings = lazyshareDefaultKeyMap
  end
  for pattern, action in defaultKeyMappings do
    KeyMapper.SetUserKeyMapping(pattern, false, action)
  end
end